####################################################
# Script Name   : sakura_grep.ps1
# Discription   : GrepGrep loop script in sakura editor
# How to        : > .\sakura_grep.ps1 "$1" "$2"
#            $1 : Grep target folder path
#            $2 : S|R|SR
#               : S :Search from Subfolders
#               : R :Regix
#               : SR:Sub folder + Regix
#       Example : > .\sakura_grep.ps1 "C:\Users\Desktop\" "SR"
# Date          : 2022/08/20
# Maker         : miyamon
####################################################

### Inital:Set Variables
### HELP https://sakura-editor.github.io/help/HLP000109.html
$SAKURA = "C:\Program Files (x86)\sakura\sakura.exe"        # TNGfB^pX
$GFOLDER = $Args[0]                                         # Ώۂ̃tH_w
$GFILE = "*.*"                                              # Ώۂ̃t@Cp^[w *.*͑St@CΏ
$GOPTDEF = "PU"                                             # PFYsóAUFWóAH:wb_Etb^o͂Ȃ
$GCODE = "99"                                               # R[h 
$RESULT = Join-Path $PSScriptRoot result.txt                # Grepʃt@C
$GOPT = $GOPTDEF,$Args[1]                                   # SFTutH_ARFK\w

Write-Output "### Grep Start ###"

### Main:Grep
$Greplists = Join-Path $PSScriptRoot greplist.csv | Import-Csv -Encoding Default

foreach ($Greplist in $Greplists) {
    $KEYWORD = ([String]$Greplist.Keyword)
    & $SAKURA -GREPMODE -GFOLDER="$GFOLDER" -GFILE="$GFILE" -GOPT="$GOPT" -GCODE="$GCODE" -GKEY="$KEYWORD" -CODE="0" | Out-File "$RESULT" -Append
}

Write-Output "### Grep Finish ###"